// Automatic FlutterFlow imports
import '/backend/backend.dart';
import '/backend/schema/structs/index.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import 'index.dart'; // Imports other custom actions
import '/flutter_flow/custom_functions.dart'; // Imports custom functions
import 'package:flutter/material.dart';
// Begin custom action code
// DO NOT REMOVE OR MODIFY THE CODE ABOVE!

import 'dart:io';
import 'package:quiz_zee/flutter_flow/admob_util.dart';
import '../../flutter_flow/admob_util.dart' as admob;

InterstitialAd? _interstitialAd;
bool success = false;

Future showInterstitialAd(
    BuildContext context, Future Function() callBack) async {
  await MobileAds.instance.initialize();
  InterstitialAd.load(
    adUnitId: Platform.isAndroid
        ? FFAppState().adsInterstitialAndroidId
        : FFAppState().adsInterstitialIosId,
    request: const AdRequest(),
    adLoadCallback: InterstitialAdLoadCallback(
      onAdLoaded: (InterstitialAd ad) {
        _interstitialAd = ad;
        print('Interstitial Ad loaded.');

        // Show the ad
        _interstitialAd?.fullScreenContentCallback = FullScreenContentCallback(
          onAdDismissedFullScreenContent: (InterstitialAd ad) async {
            // Dispose of the ad and navigate after the ad is closed
            ad.dispose();
            _interstitialAd = null;
            print('Ad dismissed. Navigating to next screen.');
            await callBack();
          },
          onAdFailedToShowFullScreenContent:
              (InterstitialAd ad, AdError error) async {
            _interstitialAd = null;
            ad.dispose();
            print('Ad failed to show. Navigating to next screen.');
            await callBack();
          },
        );

        _interstitialAd?.show();
      },
      onAdFailedToLoad: (LoadAdError error) async {
        print('Failed to load an interstitial ad: ${error.message}');
        await callBack();
      },
    ),
  );
}
