import '';
import '/backend/api_requests/api_calls.dart';
import '/componants/email_verification_dialog/email_verification_dialog_widget.dart';
import '/flutter_flow/flutter_flow_animations.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import '/shimmer/blank_component/blank_component_widget.dart';
import '/shimmer/shimmer_banner/shimmer_banner_widget.dart';
import '/shimmer/shimmer_container/shimmer_container_widget.dart';
import '/shimmer/shimmer_home_list/shimmer_home_list_widget.dart';
import '/custom_code/actions/index.dart' as actions;
import '/index.dart';
import 'dart:async';
import 'package:carousel_slider/carousel_slider.dart';
import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:flutter_animate/flutter_animate.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:lottie/lottie.dart';
import 'package:provider/provider.dart';
import 'home_screen_model.dart';
export 'home_screen_model.dart';

class HomeScreenWidget extends StatefulWidget {
  const HomeScreenWidget({super.key});

  static String routeName = 'home_screen';
  static String routePath = '/homeScreen';

  @override
  State<HomeScreenWidget> createState() => _HomeScreenWidgetState();
}

class _HomeScreenWidgetState extends State<HomeScreenWidget>
    with TickerProviderStateMixin {
  late HomeScreenModel _model;

  final scaffoldKey = GlobalKey<ScaffoldState>();

  final animationsMap = <String, AnimationInfo>{};

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => HomeScreenModel());

    // On page load action.
    SchedulerBinding.instance.addPostFrameCallback((_) async {
      if (FFAppState().isLogin) {
        _model.apiResultaov = await QuizGroup.isVerifyAccountCall.call(
          email: getJsonField(
            FFAppState().userDetils,
            r'''$.email''',
          ).toString().toString(),
        );

        if (QuizGroup.isVerifyAccountCall.success(
              (_model.apiResultaov?.jsonBody ?? ''),
            ) !=
            1) {
          await showDialog(
            context: context,
            builder: (dialogContext) {
              return Dialog(
                elevation: 0,
                insetPadding: EdgeInsets.zero,
                backgroundColor: Colors.transparent,
                alignment: AlignmentDirectional(0.0, 0.0)
                    .resolve(Directionality.of(context)),
                child: GestureDetector(
                  onTap: () {
                    FocusScope.of(dialogContext).unfocus();
                    FocusManager.instance.primaryFocus?.unfocus();
                  },
                  child: EmailVerificationDialogWidget(),
                ),
              );
            },
          );
        }
      }
      _model.getUserRankRes = await QuizGroup.getuserrankApiCall.call(
        userId: getJsonField(
          FFAppState().userDetils,
          r'''$.id''',
        ).toString().toString(),
        token: FFAppState().loginToken,
      );

      if (QuizGroup.getuserrankApiCall.success(
            (_model.getUserRankRes?.jsonBody ?? ''),
          ) ==
          1) {
        FFAppState().userPoints = QuizGroup.getuserrankApiCall
            .points(
              (_model.getUserRankRes?.jsonBody ?? ''),
            )
            .toInt();
        FFAppState().update(() {});
        if (FFAppState().userPoints < 10) {
          await actions.rewardedVideoAdInitAction();
        }
      }
    });

    animationsMap.addAll({
      'columnOnPageLoadAnimation': AnimationInfo(
        trigger: AnimationTrigger.onPageLoad,
        effectsBuilder: () => [
          MoveEffect(
            curve: Curves.linear,
            delay: 50.0.ms,
            duration: 400.0.ms,
            begin: Offset(0.0, -20.0),
            end: Offset(0.0, 0.0),
          ),
        ],
      ),
    });
  }

  @override
  void dispose() {
    _model.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    context.watch<FFAppState>();

    return Builder(
      builder: (context) => GestureDetector(
        onTap: () {
          FocusScope.of(context).unfocus();
          FocusManager.instance.primaryFocus?.unfocus();
        },
        child: Scaffold(
          key: scaffoldKey,
          backgroundColor: FlutterFlowTheme.of(context).primaryBackground,
          body: Builder(
            builder: (context) {
              if (FFAppState().connected == true) {
                return Column(
                  mainAxisSize: MainAxisSize.max,
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    FutureBuilder<ApiCallResponse>(
                      future: FFAppState()
                          .banner(
                        requestFn: () => QuizGroup.getallbannerApiCall.call(),
                      )
                          .then((result) {
                        _model.apiRequestCompleted5 = true;
                        return result;
                      }),
                      builder: (context, snapshot) {
                        // Customize what your widget looks like when it's loading.
                        if (!snapshot.hasData) {
                          return Container(
                            width: double.infinity,
                            child: ShimmerBannerWidget(),
                          );
                        }
                        final appBannerContainerGetallbannerApiResponse =
                            snapshot.data!;

                        return Container(
                          width: double.infinity,
                          decoration: BoxDecoration(
                            color: FlutterFlowTheme.of(context).primary,
                          ),
                          child: Column(
                            mainAxisSize: MainAxisSize.max,
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: [
                              Padding(
                                padding: EdgeInsetsDirectional.fromSTEB(
                                    0.0, 35.0, 0.0, 8.0),
                                child: Row(
                                  mainAxisSize: MainAxisSize.max,
                                  mainAxisAlignment:
                                      MainAxisAlignment.spaceBetween,
                                  children: [
                                    Expanded(
                                      child: Padding(
                                        padding: EdgeInsetsDirectional.fromSTEB(
                                            16.0, 0.0, 0.0, 0.0),
                                        child: Column(
                                          mainAxisSize: MainAxisSize.min,
                                          crossAxisAlignment:
                                              CrossAxisAlignment.start,
                                          children: [
                                            Text(
                                              'Hello,',
                                              style:
                                                  FlutterFlowTheme.of(context)
                                                      .bodyMedium
                                                      .override(
                                                        fontFamily: 'Roboto',
                                                        fontSize: 18.0,
                                                        letterSpacing: 0.0,
                                                        fontWeight:
                                                            FontWeight.w600,
                                                        useGoogleFonts: false,
                                                        lineHeight: 1.5,
                                                      ),
                                            ),
                                            if (FFAppState().isLogin == true)
                                              RichText(
                                                textScaler:
                                                    MediaQuery.of(context)
                                                        .textScaler,
                                                text: TextSpan(
                                                  children: [
                                                    TextSpan(
                                                      text: getJsonField(
                                                        FFAppState().userDetils,
                                                        r'''$.firstname''',
                                                      ).toString(),
                                                      style: FlutterFlowTheme
                                                              .of(context)
                                                          .bodyMedium
                                                          .override(
                                                            fontFamily:
                                                                'Roboto',
                                                            fontSize: 24.0,
                                                            letterSpacing: 0.0,
                                                            fontWeight:
                                                                FontWeight.bold,
                                                            useGoogleFonts:
                                                                false,
                                                            lineHeight: 1.5,
                                                          ),
                                                    ),
                                                    TextSpan(
                                                      text: ' ',
                                                      style: TextStyle(),
                                                    ),
                                                    TextSpan(
                                                      text: getJsonField(
                                                        FFAppState().userDetils,
                                                        r'''$.lastname''',
                                                      ).toString(),
                                                      style: TextStyle(),
                                                    ),
                                                    TextSpan(
                                                      text: '👋🏻',
                                                      style: TextStyle(),
                                                    )
                                                  ],
                                                  style: FlutterFlowTheme.of(
                                                          context)
                                                      .bodyMedium
                                                      .override(
                                                        fontFamily: 'Roboto',
                                                        fontSize: 24.0,
                                                        letterSpacing: 0.0,
                                                        fontWeight:
                                                            FontWeight.bold,
                                                        useGoogleFonts: false,
                                                        lineHeight: 1.5,
                                                      ),
                                                ),
                                                textAlign: TextAlign.start,
                                                maxLines: 1,
                                              ),
                                          ],
                                        ).animateOnPageLoad(animationsMap[
                                            'columnOnPageLoadAnimation']!),
                                      ),
                                    ),
                                    if (FFAppState().isLogin == true)
                                      Padding(
                                        padding: EdgeInsetsDirectional.fromSTEB(
                                            0.0, 20.0, 16.0, 0.0),
                                        child: FutureBuilder<ApiCallResponse>(
                                          future: FFAppState()
                                              .coins(
                                            requestFn: () => QuizGroup
                                                .getuserrankApiCall
                                                .call(
                                              userId: getJsonField(
                                                FFAppState().userDetils,
                                                r'''$.id''',
                                              ).toString(),
                                              token: FFAppState().loginToken,
                                            ),
                                          )
                                              .then((result) {
                                            _model.apiRequestCompleted3 = true;
                                            return result;
                                          }),
                                          builder: (context, snapshot) {
                                            // Customize what your widget looks like when it's loading.
                                            if (!snapshot.hasData) {
                                              return ShimmerContainerWidget();
                                            }
                                            final containerGetuserrankApiResponse =
                                                snapshot.data!;

                                            return AnimatedContainer(
                                              duration:
                                                  Duration(milliseconds: 200),
                                              curve: Curves.bounceOut,
                                              decoration: BoxDecoration(
                                                color:
                                                    FlutterFlowTheme.of(context)
                                                        .secondaryBackground,
                                                borderRadius:
                                                    BorderRadius.circular(24.0),
                                                shape: BoxShape.rectangle,
                                              ),
                                              child: Padding(
                                                padding: EdgeInsets.all(8.0),
                                                child: Row(
                                                  mainAxisSize:
                                                      MainAxisSize.min,
                                                  mainAxisAlignment:
                                                      MainAxisAlignment.center,
                                                  children: [
                                                    ClipRRect(
                                                      borderRadius:
                                                          BorderRadius.circular(
                                                              8.0),
                                                      child: SvgPicture.asset(
                                                        'assets/images/Vector.svg',
                                                        width: 20.0,
                                                        height: 20.0,
                                                        fit: BoxFit.cover,
                                                      ),
                                                    ),
                                                    RichText(
                                                      textScaler:
                                                          MediaQuery.of(context)
                                                              .textScaler,
                                                      text: TextSpan(
                                                        children: [
                                                          TextSpan(
                                                            text:
                                                                valueOrDefault<
                                                                    String>(
                                                              QuizGroup
                                                                  .getuserrankApiCall
                                                                  .points(
                                                                    containerGetuserrankApiResponse
                                                                        .jsonBody,
                                                                  )
                                                                  .toString(),
                                                              '0',
                                                            ),
                                                            style: FlutterFlowTheme
                                                                    .of(context)
                                                                .bodyMedium
                                                                .override(
                                                                  fontFamily:
                                                                      'Roboto',
                                                                  fontSize:
                                                                      15.0,
                                                                  letterSpacing:
                                                                      0.0,
                                                                  useGoogleFonts:
                                                                      false,
                                                                ),
                                                          ),
                                                          TextSpan(
                                                            text: ' points',
                                                            style: TextStyle(
                                                              fontSize: 15.0,
                                                            ),
                                                          ),
                                                          TextSpan(
                                                            text: '',
                                                            style: TextStyle(),
                                                          )
                                                        ],
                                                        style: FlutterFlowTheme
                                                                .of(context)
                                                            .bodyMedium
                                                            .override(
                                                              fontFamily:
                                                                  'Roboto',
                                                              fontSize: 18.0,
                                                              letterSpacing:
                                                                  0.0,
                                                              useGoogleFonts:
                                                                  false,
                                                            ),
                                                      ),
                                                      textAlign:
                                                          TextAlign.start,
                                                    ),
                                                  ]
                                                      .divide(
                                                          SizedBox(width: 4.0))
                                                      .addToStart(
                                                          SizedBox(width: 2.0)),
                                                ),
                                              ),
                                            );
                                          },
                                        ),
                                      ),
                                  ].divide(SizedBox(width: 16.0)),
                                ),
                              ),
                              if (QuizGroup.getallbannerApiCall
                                          .bannerDetailsList(
                                        appBannerContainerGetallbannerApiResponse
                                            .jsonBody,
                                      ) !=
                                      null &&
                                  (QuizGroup.getallbannerApiCall
                                          .bannerDetailsList(
                                    appBannerContainerGetallbannerApiResponse
                                        .jsonBody,
                                  ))!
                                      .isNotEmpty)
                                Container(
                                  width: double.infinity,
                                  decoration: BoxDecoration(),
                                  child: Column(
                                    mainAxisSize: MainAxisSize.min,
                                    children: [
                                      Builder(
                                        builder: (context) {
                                          final bannerList =
                                              (QuizGroup.getallbannerApiCall
                                                          .bannerDetailsList(
                                                            appBannerContainerGetallbannerApiResponse
                                                                .jsonBody,
                                                          )
                                                          ?.toList() ??
                                                      [])
                                                  .take(5)
                                                  .toList();

                                          return Container(
                                            width: double.infinity,
                                            height: 157.0,
                                            child: CarouselSlider.builder(
                                              itemCount: bannerList.length,
                                              itemBuilder: (context,
                                                  bannerListIndex, _) {
                                                final bannerListItem =
                                                    bannerList[bannerListIndex];
                                                return InkWell(
                                                  splashColor:
                                                      Colors.transparent,
                                                  focusColor:
                                                      Colors.transparent,
                                                  hoverColor:
                                                      Colors.transparent,
                                                  highlightColor:
                                                      Colors.transparent,
                                                  onTap: () async {
                                                    if (FFAppState().isLogin ==
                                                        true) {
                                                      context.pushNamed(
                                                        DetailScreenWidget
                                                            .routeName,
                                                        queryParameters: {
                                                          'catId':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.categoryId''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'name':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.name''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'image':
                                                              serializeParam(
                                                            '${FFAppConstants.imageBaseURL}${getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.image''',
                                                            ).toString()}',
                                                            ParamType.String,
                                                          ),
                                                          'quizTime':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.minutes_per_quiz''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'description':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.description''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'title':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.name''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'quizID':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId._id''',
                                                            ).toString(),
                                                            ParamType.String,
                                                          ),
                                                          'ques':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.totalQuestions''',
                                                            ),
                                                            ParamType.int,
                                                          ),
                                                          'timerStatus':
                                                              serializeParam(
                                                            getJsonField(
                                                              bannerListItem,
                                                              r'''$.quizId.timer_status''',
                                                            ),
                                                            ParamType.int,
                                                          ),
                                                        }.withoutNulls,
                                                      );
                                                    } else {
                                                      ScaffoldMessenger.of(
                                                              context)
                                                          .showSnackBar(
                                                        SnackBar(
                                                          content: Text(
                                                            'Please login first for View Content',
                                                            style: TextStyle(
                                                              fontFamily:
                                                                  'Roboto',
                                                              color: FlutterFlowTheme
                                                                      .of(context)
                                                                  .primaryText,
                                                              fontSize: 16.0,
                                                            ),
                                                          ),
                                                          duration: Duration(
                                                              milliseconds:
                                                                  2000),
                                                          backgroundColor:
                                                              FlutterFlowTheme.of(
                                                                      context)
                                                                  .secondary,
                                                          action:
                                                              SnackBarAction(
                                                            label: 'Login',
                                                            textColor:
                                                                FlutterFlowTheme.of(
                                                                        context)
                                                                    .primaryText,
                                                            onPressed:
                                                                () async {
                                                              context.goNamed(
                                                                  LoginScreenWidget
                                                                      .routeName);
                                                            },
                                                          ),
                                                        ),
                                                      );
                                                    }
                                                  },
                                                  child: Container(
                                                    width: double.infinity,
                                                    height: 157.0,
                                                    decoration: BoxDecoration(
                                                      color:
                                                          FlutterFlowTheme.of(
                                                                  context)
                                                              .secondary,
                                                      borderRadius:
                                                          BorderRadius.circular(
                                                              8.0),
                                                    ),
                                                    child: ClipRRect(
                                                      borderRadius:
                                                          BorderRadius.circular(
                                                              8.0),
                                                      child: CachedNetworkImage(
                                                        fadeInDuration:
                                                            Duration(
                                                                milliseconds:
                                                                    200),
                                                        fadeOutDuration:
                                                            Duration(
                                                                milliseconds:
                                                                    200),
                                                        imageUrl: getJsonField(
                                                                  bannerListItem,
                                                                  r'''$.image''',
                                                                ) !=
                                                                null
                                                            ? '${FFAppConstants.imageBaseURL}${getJsonField(
                                                                bannerListItem,
                                                                r'''$.image''',
                                                              ).toString()}'
                                                            : '',
                                                        width: double.infinity,
                                                        height: double.infinity,
                                                        fit: BoxFit.cover,
                                                        alignment:
                                                            Alignment(0.0, 0.0),
                                                        errorWidget: (context,
                                                                error,
                                                                stackTrace) =>
                                                            Image.asset(
                                                          'assets/images/error_image.png',
                                                          width:
                                                              double.infinity,
                                                          height:
                                                              double.infinity,
                                                          fit: BoxFit.cover,
                                                          alignment: Alignment(
                                                              0.0, 0.0),
                                                        ),
                                                      ),
                                                    ),
                                                  ),
                                                );
                                              },
                                              carouselController: _model
                                                      .carouselController ??=
                                                  CarouselSliderController(),
                                              options: CarouselOptions(
                                                initialPage: max(
                                                    0,
                                                    min(0,
                                                        bannerList.length - 1)),
                                                viewportFraction: 0.85,
                                                disableCenter: true,
                                                enlargeCenterPage: true,
                                                enlargeFactor: 0.25,
                                                enableInfiniteScroll: true,
                                                scrollDirection:
                                                    Axis.horizontal,
                                                autoPlay: true,
                                                autoPlayAnimationDuration:
                                                    Duration(milliseconds: 800),
                                                autoPlayInterval: Duration(
                                                    milliseconds: (800 + 4000)),
                                                autoPlayCurve: Curves.linear,
                                                pauseAutoPlayInFiniteScroll:
                                                    true,
                                                onPageChanged:
                                                    (index, _) async {
                                                  _model.carouselCurrentIndex =
                                                      index;
                                                  _model.sliderIndex = _model
                                                      .carouselCurrentIndex;
                                                  safeSetState(() {});
                                                },
                                              ),
                                            ),
                                          );
                                        },
                                      ),
                                      Padding(
                                        padding: EdgeInsetsDirectional.fromSTEB(
                                            0.0, 8.0, 0.0, 8.0),
                                        child: Builder(
                                          builder: (context) {
                                            final bannerLists =
                                                (QuizGroup.getallbannerApiCall
                                                            .bannerDetailsList(
                                                              appBannerContainerGetallbannerApiResponse
                                                                  .jsonBody,
                                                            )
                                                            ?.toList() ??
                                                        [])
                                                    .take(5)
                                                    .toList();

                                            return Row(
                                              mainAxisSize: MainAxisSize.max,
                                              mainAxisAlignment:
                                                  MainAxisAlignment.center,
                                              children: List.generate(
                                                  bannerLists.length,
                                                  (bannerListsIndex) {
                                                final bannerListsItem =
                                                    bannerLists[
                                                        bannerListsIndex];
                                                return Padding(
                                                  padding: EdgeInsetsDirectional
                                                      .fromSTEB(
                                                          0.0, 0.0, 4.0, 0.0),
                                                  child: Container(
                                                    width: bannerListsIndex ==
                                                            _model
                                                                .carouselCurrentIndex
                                                        ? 16.0
                                                        : 6.0,
                                                    height: 6.0,
                                                    decoration: BoxDecoration(
                                                      color: bannerListsIndex ==
                                                              _model
                                                                  .carouselCurrentIndex
                                                          ? FlutterFlowTheme.of(
                                                                  context)
                                                              .primaryText
                                                          : Color(0x33000000),
                                                      borderRadius:
                                                          BorderRadius.circular(
                                                              100.0),
                                                      shape: BoxShape.rectangle,
                                                    ),
                                                  ),
                                                );
                                              }),
                                            );
                                          },
                                        ),
                                      ),
                                    ].addToStart(SizedBox(height: 8.0)),
                                  ),
                                ),
                            ],
                          ),
                        );
                      },
                    ),
                    Expanded(
                      child: FutureBuilder<ApiCallResponse>(
                        future: FFAppState()
                            .selfChalange(
                          requestFn: () =>
                              QuizGroup.getpointssettingApiCall.call(
                            token: FFAppState().loginToken,
                          ),
                        )
                            .then((result) {
                          _model.apiRequestCompleted1 = true;
                          return result;
                        }),
                        builder: (context, snapshot) {
                          // Customize what your widget looks like when it's loading.
                          if (!snapshot.hasData) {
                            return Container(
                              width: double.infinity,
                              child: ShimmerHomeListWidget(),
                            );
                          }
                          final selfContainerGetpointssettingApiResponse =
                              snapshot.data!;

                          return Container(
                            width: double.infinity,
                            decoration: BoxDecoration(),
                            child: FutureBuilder<ApiCallResponse>(
                              future: FFAppState()
                                  .featured(
                                requestFn: () => GetFeatureCategoryCall.call(
                                  baseURL: FFAppConstants.baseURL,
                                ),
                              )
                                  .then((result) {
                                _model.apiRequestCompleted4 = true;
                                return result;
                              }),
                              builder: (context, snapshot) {
                                // Customize what your widget looks like when it's loading.
                                if (!snapshot.hasData) {
                                  return Container(
                                    width: double.infinity,
                                    child: ShimmerHomeListWidget(),
                                  );
                                }
                                final feautureContainerGetFeatureCategoryResponse =
                                    snapshot.data!;

                                return Container(
                                  decoration: BoxDecoration(),
                                  child: FutureBuilder<ApiCallResponse>(
                                    future: FFAppState()
                                        .categoryViewall(
                                      requestFn: () =>
                                          QuizGroup.getAllCategoriesCall.call(),
                                    )
                                        .then((result) {
                                      _model.apiRequestCompleted2 = true;
                                      return result;
                                    }),
                                    builder: (context, snapshot) {
                                      // Customize what your widget looks like when it's loading.
                                      if (!snapshot.hasData) {
                                        return BlankComponentWidget();
                                      }
                                      final categoriesContainerGetAllCategoriesResponse =
                                          snapshot.data!;

                                      return Container(
                                        width: double.infinity,
                                        height: double.infinity,
                                        decoration: BoxDecoration(),
                                        child: Builder(
                                          builder: (context) {
                                            if ((QuizGroup.getAllCategoriesCall
                                                        .success(
                                                      categoriesContainerGetAllCategoriesResponse
                                                          .jsonBody,
                                                    ) ==
                                                    2) ||
                                                (GetFeatureCategoryCall.success(
                                                      feautureContainerGetFeatureCategoryResponse
                                                          .jsonBody,
                                                    ) ==
                                                    2) ||
                                                (QuizGroup
                                                        .getpointssettingApiCall
                                                        .success(
                                                      selfContainerGetpointssettingApiResponse
                                                          .jsonBody,
                                                    ) ==
                                                    2)) {
                                              return Align(
                                                alignment: AlignmentDirectional(
                                                    0.0, 0.0),
                                                child: Padding(
                                                  padding: EdgeInsetsDirectional
                                                      .fromSTEB(
                                                          16.0, 0.0, 16.0, 0.0),
                                                  child: Text(
                                                    valueOrDefault<String>(
                                                      GetFeatureCategoryCall
                                                          .message(
                                                        feautureContainerGetFeatureCategoryResponse
                                                            .jsonBody,
                                                      ),
                                                      'Message',
                                                    ),
                                                    style: FlutterFlowTheme.of(
                                                            context)
                                                        .bodyMedium
                                                        .override(
                                                          fontFamily: 'Roboto',
                                                          fontSize: 18.0,
                                                          letterSpacing: 0.0,
                                                          fontWeight:
                                                              FontWeight.w600,
                                                          useGoogleFonts: false,
                                                          lineHeight: 1.5,
                                                        ),
                                                  ),
                                                ),
                                              );
                                            } else {
                                              return RefreshIndicator(
                                                key: Key(
                                                    'RefreshIndicator_hrdannp9'),
                                                color:
                                                    FlutterFlowTheme.of(context)
                                                        .primary,
                                                backgroundColor:
                                                    FlutterFlowTheme.of(context)
                                                        .primaryBackground,
                                                onRefresh: () async {
                                                  await Future.wait([
                                                    Future(() async {
                                                      safeSetState(() {
                                                        FFAppState()
                                                            .clearBannerCache();
                                                        _model.apiRequestCompleted5 =
                                                            false;
                                                      });
                                                      await _model
                                                          .waitForApiRequestCompleted5(
                                                              maxWait: 3000);
                                                    }),
                                                    Future(() async {
                                                      safeSetState(() {
                                                        FFAppState()
                                                            .clearCategoryViewallCache();
                                                        _model.apiRequestCompleted2 =
                                                            false;
                                                      });
                                                      await _model
                                                          .waitForApiRequestCompleted2(
                                                              maxWait: 3000);
                                                    }),
                                                    Future(() async {
                                                      safeSetState(() {
                                                        FFAppState()
                                                            .clearFeaturedCache();
                                                        _model.apiRequestCompleted4 =
                                                            false;
                                                      });
                                                      await _model
                                                          .waitForApiRequestCompleted4(
                                                              maxWait: 3000);
                                                    }),
                                                    Future(() async {
                                                      safeSetState(() {
                                                        FFAppState()
                                                            .clearSelfChalangeCache();
                                                        _model.apiRequestCompleted1 =
                                                            false;
                                                      });
                                                      await _model
                                                          .waitForApiRequestCompleted1(
                                                              maxWait: 3000);
                                                    }),
                                                    Future(() async {
                                                      safeSetState(() {
                                                        FFAppState()
                                                            .clearCoinsCache();
                                                        _model.apiRequestCompleted3 =
                                                            false;
                                                      });
                                                      await _model
                                                          .waitForApiRequestCompleted3(
                                                              maxWait: 3000);
                                                    }),
                                                  ]);
                                                },
                                                child: SingleChildScrollView(
                                                  primary: false,
                                                  physics:
                                                      const AlwaysScrollableScrollPhysics(),
                                                  child: Column(
                                                    mainAxisSize:
                                                        MainAxisSize.max,
                                                    crossAxisAlignment:
                                                        CrossAxisAlignment
                                                            .start,
                                                    children: [
                                                      if (QuizGroup
                                                                  .getAllCategoriesCall
                                                                  .category(
                                                                categoriesContainerGetAllCategoriesResponse
                                                                    .jsonBody,
                                                              ) !=
                                                              null &&
                                                          (QuizGroup
                                                                  .getAllCategoriesCall
                                                                  .category(
                                                            categoriesContainerGetAllCategoriesResponse
                                                                .jsonBody,
                                                          ))!
                                                              .isNotEmpty)
                                                        Padding(
                                                          padding:
                                                              EdgeInsetsDirectional
                                                                  .fromSTEB(
                                                                      0.0,
                                                                      0.0,
                                                                      0.0,
                                                                      16.0),
                                                          child: Column(
                                                            mainAxisSize:
                                                                MainAxisSize
                                                                    .max,
                                                            crossAxisAlignment:
                                                                CrossAxisAlignment
                                                                    .start,
                                                            children: [
                                                              Padding(
                                                                padding: EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                        16.0,
                                                                        0.0,
                                                                        16.0,
                                                                        16.0),
                                                                child: Row(
                                                                  mainAxisSize:
                                                                      MainAxisSize
                                                                          .max,
                                                                  mainAxisAlignment:
                                                                      MainAxisAlignment
                                                                          .spaceBetween,
                                                                  children: [
                                                                    Text(
                                                                      'Categories',
                                                                      style: FlutterFlowTheme.of(
                                                                              context)
                                                                          .bodyMedium
                                                                          .override(
                                                                            fontFamily:
                                                                                'Roboto',
                                                                            fontSize:
                                                                                18.0,
                                                                            letterSpacing:
                                                                                0.0,
                                                                            fontWeight:
                                                                                FontWeight.w600,
                                                                            useGoogleFonts:
                                                                                false,
                                                                            lineHeight:
                                                                                1.5,
                                                                          ),
                                                                    ),
                                                                    InkWell(
                                                                      splashColor:
                                                                          Colors
                                                                              .transparent,
                                                                      focusColor:
                                                                          Colors
                                                                              .transparent,
                                                                      hoverColor:
                                                                          Colors
                                                                              .transparent,
                                                                      highlightColor:
                                                                          Colors
                                                                              .transparent,
                                                                      onTap:
                                                                          () async {
                                                                        context.pushNamed(
                                                                            CategoryViewallWidget.routeName);
                                                                      },
                                                                      child:
                                                                          Text(
                                                                        'View all',
                                                                        style: FlutterFlowTheme.of(context)
                                                                            .bodyMedium
                                                                            .override(
                                                                              fontFamily: 'Roboto',
                                                                              fontSize: 15.0,
                                                                              letterSpacing: 0.0,
                                                                              useGoogleFonts: false,
                                                                              lineHeight: 1.5,
                                                                            ),
                                                                      ),
                                                                    ),
                                                                  ],
                                                                ),
                                                              ),
                                                              Container(
                                                                width: double
                                                                    .infinity,
                                                                height: 105.0,
                                                                decoration:
                                                                    BoxDecoration(),
                                                                child: Builder(
                                                                  builder:
                                                                      (context) {
                                                                    final categories = (QuizGroup.getAllCategoriesCall
                                                                                .category(
                                                                                  categoriesContainerGetAllCategoriesResponse.jsonBody,
                                                                                )
                                                                                ?.toList() ??
                                                                            [])
                                                                        .take(4)
                                                                        .toList();

                                                                    return ListView
                                                                        .separated(
                                                                      padding:
                                                                          EdgeInsets
                                                                              .fromLTRB(
                                                                        16.0,
                                                                        0,
                                                                        16.0,
                                                                        0,
                                                                      ),
                                                                      primary:
                                                                          false,
                                                                      shrinkWrap:
                                                                          true,
                                                                      scrollDirection:
                                                                          Axis.horizontal,
                                                                      itemCount:
                                                                          categories
                                                                              .length,
                                                                      separatorBuilder: (_,
                                                                              __) =>
                                                                          SizedBox(
                                                                              width: 16.0),
                                                                      itemBuilder:
                                                                          (context,
                                                                              categoriesIndex) {
                                                                        final categoriesItem =
                                                                            categories[categoriesIndex];
                                                                        return InkWell(
                                                                          splashColor:
                                                                              Colors.transparent,
                                                                          focusColor:
                                                                              Colors.transparent,
                                                                          hoverColor:
                                                                              Colors.transparent,
                                                                          highlightColor:
                                                                              Colors.transparent,
                                                                          onTap:
                                                                              () async {
                                                                            context.pushNamed(
                                                                              CategoryDetailPageWidget.routeName,
                                                                              queryParameters: {
                                                                                'title': serializeParam(
                                                                                  getJsonField(
                                                                                    categoriesItem,
                                                                                    r'''$.name''',
                                                                                  ).toString(),
                                                                                  ParamType.String,
                                                                                ),
                                                                                'catId': serializeParam(
                                                                                  getJsonField(
                                                                                    categoriesItem,
                                                                                    r'''$._id''',
                                                                                  ).toString(),
                                                                                  ParamType.String,
                                                                                ),
                                                                              }.withoutNulls,
                                                                            );
                                                                          },
                                                                          child:
                                                                              Container(
                                                                            width:
                                                                                87.0,
                                                                            decoration:
                                                                                BoxDecoration(
                                                                              color: FlutterFlowTheme.of(context).secondaryBackground,
                                                                              borderRadius: BorderRadius.circular(12.0),
                                                                            ),
                                                                            child:
                                                                                Padding(
                                                                              padding: EdgeInsetsDirectional.fromSTEB(5.0, 0.0, 5.0, 0.0),
                                                                              child: Column(
                                                                                mainAxisSize: MainAxisSize.max,
                                                                                mainAxisAlignment: MainAxisAlignment.center,
                                                                                children: [
                                                                                  Padding(
                                                                                    padding: EdgeInsetsDirectional.fromSTEB(0.0, 0.0, 0.0, 8.0),
                                                                                    child: Container(
                                                                                      width: 47.0,
                                                                                      height: 47.0,
                                                                                      decoration: BoxDecoration(
                                                                                        color: FlutterFlowTheme.of(context).grey,
                                                                                        shape: BoxShape.circle,
                                                                                      ),
                                                                                      alignment: AlignmentDirectional(0.0, 0.0),
                                                                                      child: ClipRRect(
                                                                                        borderRadius: BorderRadius.circular(0.0),
                                                                                        child: CachedNetworkImage(
                                                                                          fadeInDuration: Duration(milliseconds: 200),
                                                                                          fadeOutDuration: Duration(milliseconds: 200),
                                                                                          imageUrl: '${FFAppConstants.imageBaseURL}${getJsonField(
                                                                                            categoriesItem,
                                                                                            r'''$.image''',
                                                                                          ).toString()}',
                                                                                          width: 24.0,
                                                                                          height: 24.0,
                                                                                          fit: BoxFit.cover,
                                                                                          errorWidget: (context, error, stackTrace) => Image.asset(
                                                                                            'assets/images/error_image.png',
                                                                                            width: 24.0,
                                                                                            height: 24.0,
                                                                                            fit: BoxFit.cover,
                                                                                          ),
                                                                                        ),
                                                                                      ),
                                                                                    ),
                                                                                  ),
                                                                                  Text(
                                                                                    getJsonField(
                                                                                      categoriesItem,
                                                                                      r'''$.name''',
                                                                                    ).toString(),
                                                                                    textAlign: TextAlign.center,
                                                                                    maxLines: 2,
                                                                                    style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                          fontFamily: 'Roboto',
                                                                                          fontSize: 14.0,
                                                                                          letterSpacing: 0.0,
                                                                                          useGoogleFonts: false,
                                                                                        ),
                                                                                  ),
                                                                                ],
                                                                              ),
                                                                            ),
                                                                          ),
                                                                        );
                                                                      },
                                                                    );
                                                                  },
                                                                ),
                                                              ),
                                                            ],
                                                          ),
                                                        ),
                                                      if (GetFeatureCategoryCall
                                                                  .categoryDetails(
                                                                feautureContainerGetFeatureCategoryResponse
                                                                    .jsonBody,
                                                              ) !=
                                                              null &&
                                                          (GetFeatureCategoryCall
                                                                  .categoryDetails(
                                                            feautureContainerGetFeatureCategoryResponse
                                                                .jsonBody,
                                                          ))!
                                                              .isNotEmpty)
                                                        Container(
                                                          width:
                                                              double.infinity,
                                                          decoration:
                                                              BoxDecoration(),
                                                          child: Builder(
                                                            builder: (context) {
                                                              final featured =
                                                                  GetFeatureCategoryCall
                                                                          .categoryDetails(
                                                                        feautureContainerGetFeatureCategoryResponse
                                                                            .jsonBody,
                                                                      )?.toList() ??
                                                                      [];

                                                              return Column(
                                                                mainAxisSize:
                                                                    MainAxisSize
                                                                        .min,
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: List.generate(
                                                                    featured
                                                                        .length,
                                                                    (featuredIndex) {
                                                                  final featuredItem =
                                                                      featured[
                                                                          featuredIndex];
                                                                  return Container(
                                                                    decoration:
                                                                        BoxDecoration(),
                                                                    child:
                                                                        Padding(
                                                                      padding: EdgeInsetsDirectional.fromSTEB(
                                                                          16.0,
                                                                          0.0,
                                                                          16.0,
                                                                          16.0),
                                                                      child:
                                                                          Column(
                                                                        mainAxisSize:
                                                                            MainAxisSize.min,
                                                                        crossAxisAlignment:
                                                                            CrossAxisAlignment.start,
                                                                        children: [
                                                                          Padding(
                                                                            padding: EdgeInsetsDirectional.fromSTEB(
                                                                                0.0,
                                                                                0.0,
                                                                                0.0,
                                                                                16.0),
                                                                            child:
                                                                                Row(
                                                                              mainAxisSize: MainAxisSize.max,
                                                                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                                                              children: [
                                                                                Text(
                                                                                  getJsonField(
                                                                                    featuredItem,
                                                                                    r'''$.name''',
                                                                                  ).toString(),
                                                                                  style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                        fontFamily: 'Roboto',
                                                                                        fontSize: 18.0,
                                                                                        letterSpacing: 0.0,
                                                                                        fontWeight: FontWeight.w600,
                                                                                        useGoogleFonts: false,
                                                                                        lineHeight: 1.5,
                                                                                      ),
                                                                                ),
                                                                                InkWell(
                                                                                  splashColor: Colors.transparent,
                                                                                  focusColor: Colors.transparent,
                                                                                  hoverColor: Colors.transparent,
                                                                                  highlightColor: Colors.transparent,
                                                                                  onTap: () async {
                                                                                    context.pushNamed(
                                                                                      FeaturedCategoryDetailWidget.routeName,
                                                                                      queryParameters: {
                                                                                        'title': serializeParam(
                                                                                          getJsonField(
                                                                                            featuredItem,
                                                                                            r'''$.name''',
                                                                                          ).toString(),
                                                                                          ParamType.String,
                                                                                        ),
                                                                                        'quizList': serializeParam(
                                                                                          getJsonField(
                                                                                            featuredItem,
                                                                                            r'''$.quizzes''',
                                                                                            true,
                                                                                          ),
                                                                                          ParamType.JSON,
                                                                                          isList: true,
                                                                                        ),
                                                                                        'index': serializeParam(
                                                                                          featuredIndex,
                                                                                          ParamType.int,
                                                                                        ),
                                                                                      }.withoutNulls,
                                                                                    );
                                                                                  },
                                                                                  child: Text(
                                                                                    'View all',
                                                                                    style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                          fontFamily: 'Roboto',
                                                                                          fontSize: 15.0,
                                                                                          letterSpacing: 0.0,
                                                                                          useGoogleFonts: false,
                                                                                          lineHeight: 1.5,
                                                                                        ),
                                                                                  ),
                                                                                ),
                                                                              ],
                                                                            ),
                                                                          ),
                                                                          Builder(
                                                                            builder:
                                                                                (context) {
                                                                              final quiz = getJsonField(
                                                                                featuredItem,
                                                                                r'''$.quizzes''',
                                                                              ).toList();

                                                                              return Column(
                                                                                mainAxisSize: MainAxisSize.min,
                                                                                children: List.generate(quiz.length, (quizIndex) {
                                                                                  final quizItem = quiz[quizIndex];
                                                                                  return InkWell(
                                                                                    splashColor: Colors.transparent,
                                                                                    focusColor: Colors.transparent,
                                                                                    hoverColor: Colors.transparent,
                                                                                    highlightColor: Colors.transparent,
                                                                                    onTap: () async {
                                                                                      if (FFAppState().isLogin == true) {
                                                                                        context.pushNamed(
                                                                                          DetailScreenWidget.routeName,
                                                                                          queryParameters: {
                                                                                            'catId': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.categoryId''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'name': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.name''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'image': serializeParam(
                                                                                              '${FFAppConstants.imageBaseURL}${getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.image''',
                                                                                              ).toString()}',
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'quizTime': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.minutes_per_quiz''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'description': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.description''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'quizID': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$._id''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'ques': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.total_questions''',
                                                                                              ),
                                                                                              ParamType.int,
                                                                                            ),
                                                                                            'title': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.name''',
                                                                                              ).toString(),
                                                                                              ParamType.String,
                                                                                            ),
                                                                                            'timerStatus': serializeParam(
                                                                                              getJsonField(
                                                                                                quizItem,
                                                                                                r'''$.timer_status''',
                                                                                              ),
                                                                                              ParamType.int,
                                                                                            ),
                                                                                          }.withoutNulls,
                                                                                        );
                                                                                      } else {
                                                                                        ScaffoldMessenger.of(context).showSnackBar(
                                                                                          SnackBar(
                                                                                            content: Text(
                                                                                              'Please login first for View Content',
                                                                                              style: TextStyle(
                                                                                                fontFamily: 'Roboto',
                                                                                                color: FlutterFlowTheme.of(context).primaryText,
                                                                                                fontSize: 16.0,
                                                                                              ),
                                                                                            ),
                                                                                            duration: Duration(milliseconds: 2000),
                                                                                            backgroundColor: FlutterFlowTheme.of(context).secondary,
                                                                                            action: SnackBarAction(
                                                                                              label: 'Login',
                                                                                              textColor: FlutterFlowTheme.of(context).primaryText,
                                                                                              onPressed: () async {
                                                                                                context.goNamed(LoginScreenWidget.routeName);
                                                                                              },
                                                                                            ),
                                                                                          ),
                                                                                        );
                                                                                      }
                                                                                    },
                                                                                    child: Container(
                                                                                      width: double.infinity,
                                                                                      height: 118.0,
                                                                                      decoration: BoxDecoration(
                                                                                        color: FlutterFlowTheme.of(context).secondaryBackground,
                                                                                        borderRadius: BorderRadius.circular(12.0),
                                                                                      ),
                                                                                      child: Row(
                                                                                        mainAxisSize: MainAxisSize.max,
                                                                                        crossAxisAlignment: CrossAxisAlignment.start,
                                                                                        children: [
                                                                                          Column(
                                                                                            mainAxisSize: MainAxisSize.max,
                                                                                            mainAxisAlignment: MainAxisAlignment.center,
                                                                                            children: [
                                                                                              Builder(
                                                                                                builder: (context) {
                                                                                                  if (getJsonField(
                                                                                                        GetFeatureCategoryCall.quizzes(
                                                                                                          feautureContainerGetFeatureCategoryResponse.jsonBody,
                                                                                                        )?.elementAtOrNull(featuredIndex),
                                                                                                        r'''$[:].image''',
                                                                                                      ) !=
                                                                                                      null) {
                                                                                                    return ClipRRect(
                                                                                                      borderRadius: BorderRadius.circular(8.0),
                                                                                                      child: CachedNetworkImage(
                                                                                                        fadeInDuration: Duration(milliseconds: 500),
                                                                                                        fadeOutDuration: Duration(milliseconds: 500),
                                                                                                        imageUrl: valueOrDefault<String>(
                                                                                                          '${FFAppConstants.imageBaseURL}${getJsonField(
                                                                                                            quizItem,
                                                                                                            r'''$.image''',
                                                                                                          ).toString()}',
                                                                                                          'https://picsum.photos/seed/223/600',
                                                                                                        ),
                                                                                                        width: 70.0,
                                                                                                        height: 70.0,
                                                                                                        fit: BoxFit.cover,
                                                                                                      ),
                                                                                                    );
                                                                                                  } else {
                                                                                                    return ClipRRect(
                                                                                                      borderRadius: BorderRadius.circular(8.0),
                                                                                                      child: CachedNetworkImage(
                                                                                                        fadeInDuration: Duration(milliseconds: 500),
                                                                                                        fadeOutDuration: Duration(milliseconds: 500),
                                                                                                        imageUrl: 'https://picsum.photos/seed/223/600',
                                                                                                        width: 70.0,
                                                                                                        height: 70.0,
                                                                                                        fit: BoxFit.cover,
                                                                                                      ),
                                                                                                    );
                                                                                                  }
                                                                                                },
                                                                                              ),
                                                                                            ],
                                                                                          ),
                                                                                          Expanded(
                                                                                            child: Padding(
                                                                                              padding: EdgeInsetsDirectional.fromSTEB(16.0, 0.0, 0.0, 0.0),
                                                                                              child: Column(
                                                                                                mainAxisSize: MainAxisSize.max,
                                                                                                mainAxisAlignment: MainAxisAlignment.center,
                                                                                                crossAxisAlignment: CrossAxisAlignment.start,
                                                                                                children: [
                                                                                                  Text(
                                                                                                    getJsonField(
                                                                                                      quizItem,
                                                                                                      r'''$.name''',
                                                                                                    ).toString(),
                                                                                                    maxLines: 2,
                                                                                                    style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                                          fontFamily: 'Roboto',
                                                                                                          fontSize: 17.0,
                                                                                                          letterSpacing: 0.0,
                                                                                                          fontWeight: FontWeight.w600,
                                                                                                          useGoogleFonts: false,
                                                                                                          lineHeight: 1.2,
                                                                                                        ),
                                                                                                  ),
                                                                                                  Row(
                                                                                                    mainAxisSize: MainAxisSize.max,
                                                                                                    children: [
                                                                                                      Padding(
                                                                                                        padding: EdgeInsetsDirectional.fromSTEB(0.0, 12.0, 0.0, 0.0),
                                                                                                        child: Text(
                                                                                                          '${getJsonField(
                                                                                                            quizItem,
                                                                                                            r'''$.total_questions''',
                                                                                                          ).toString()} questions',
                                                                                                          maxLines: 2,
                                                                                                          style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                                                fontFamily: 'Roboto',
                                                                                                                fontSize: 17.0,
                                                                                                                letterSpacing: 0.0,
                                                                                                                fontWeight: FontWeight.normal,
                                                                                                                useGoogleFonts: false,
                                                                                                                lineHeight: 1.2,
                                                                                                              ),
                                                                                                        ),
                                                                                                      ),
                                                                                                      Padding(
                                                                                                        padding: EdgeInsetsDirectional.fromSTEB(0.0, 12.0, 0.0, 0.0),
                                                                                                        child: Container(
                                                                                                          width: 5.0,
                                                                                                          height: 5.0,
                                                                                                          decoration: BoxDecoration(
                                                                                                            color: FlutterFlowTheme.of(context).black,
                                                                                                            shape: BoxShape.circle,
                                                                                                          ),
                                                                                                        ),
                                                                                                      ),
                                                                                                      Padding(
                                                                                                        padding: EdgeInsetsDirectional.fromSTEB(0.0, 12.0, 0.0, 0.0),
                                                                                                        child: RichText(
                                                                                                          textScaler: MediaQuery.of(context).textScaler,
                                                                                                          text: TextSpan(
                                                                                                            children: [
                                                                                                              TextSpan(
                                                                                                                text: getJsonField(
                                                                                                                  quizItem,
                                                                                                                  r'''$.minutes_per_quiz''',
                                                                                                                ).toString(),
                                                                                                                style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                                                      fontFamily: 'Roboto',
                                                                                                                      fontSize: 17.0,
                                                                                                                      letterSpacing: 0.0,
                                                                                                                      fontWeight: FontWeight.normal,
                                                                                                                      useGoogleFonts: false,
                                                                                                                      lineHeight: 1.2,
                                                                                                                    ),
                                                                                                              ),
                                                                                                              TextSpan(
                                                                                                                text: ' min',
                                                                                                                style: TextStyle(
                                                                                                                  color: FlutterFlowTheme.of(context).black,
                                                                                                                  fontSize: 17.0,
                                                                                                                ),
                                                                                                              )
                                                                                                            ],
                                                                                                            style: TextStyle(),
                                                                                                          ),
                                                                                                        ),
                                                                                                      ),
                                                                                                    ].divide(SizedBox(width: 5.0)),
                                                                                                  ),
                                                                                                ],
                                                                                              ),
                                                                                            ),
                                                                                          ),
                                                                                        ].addToStart(SizedBox(width: 10.0)).addToEnd(SizedBox(width: 10.0)),
                                                                                      ),
                                                                                    ),
                                                                                  );
                                                                                }).divide(SizedBox(height: 16.0)),
                                                                              );
                                                                            },
                                                                          ),
                                                                        ],
                                                                      ),
                                                                    ),
                                                                  );
                                                                }),
                                                              );
                                                            },
                                                          ),
                                                        ),
                                                      if (FFAppState()
                                                              .isLogin ==
                                                          true)
                                                        Container(
                                                          width:
                                                              double.infinity,
                                                          decoration:
                                                              BoxDecoration(),
                                                          child: Visibility(
                                                            visible: QuizGroup
                                                                    .getpointssettingApiCall
                                                                    .selfMode(
                                                                  selfContainerGetpointssettingApiResponse
                                                                      .jsonBody,
                                                                ) ==
                                                                1,
                                                            child: Padding(
                                                              padding: EdgeInsetsDirectional
                                                                  .fromSTEB(
                                                                      16.0,
                                                                      0.0,
                                                                      16.0,
                                                                      valueOrDefault<
                                                                          double>(
                                                                        FFAppState().countAd !=
                                                                                2
                                                                            ? 0.0
                                                                            : 16.0,
                                                                        0.0,
                                                                      )),
                                                              child: InkWell(
                                                                splashColor: Colors
                                                                    .transparent,
                                                                focusColor: Colors
                                                                    .transparent,
                                                                hoverColor: Colors
                                                                    .transparent,
                                                                highlightColor:
                                                                    Colors
                                                                        .transparent,
                                                                onTap:
                                                                    () async {
                                                                  FFAppState()
                                                                      .selectedQuizType = '';
                                                                  FFAppState()
                                                                      .selectedQuizAmount = '';
                                                                  FFAppState()
                                                                      .selectedQuizDuration = '';
                                                                  safeSetState(
                                                                      () {});

                                                                  context.pushNamed(
                                                                      SelfChellengeWidget
                                                                          .routeName);
                                                                },
                                                                child:
                                                                    Container(
                                                                  width: 396.0,
                                                                  height: 148.0,
                                                                  decoration:
                                                                      BoxDecoration(
                                                                    color: FlutterFlowTheme.of(
                                                                            context)
                                                                        .secondaryBackground,
                                                                    image:
                                                                        DecorationImage(
                                                                      fit: BoxFit
                                                                          .cover,
                                                                      image: Image
                                                                          .asset(
                                                                        'assets/images/Rectangle_3463277.png',
                                                                      ).image,
                                                                    ),
                                                                    borderRadius:
                                                                        BorderRadius.circular(
                                                                            12.0),
                                                                  ),
                                                                  child: Column(
                                                                    mainAxisSize:
                                                                        MainAxisSize
                                                                            .max,
                                                                    mainAxisAlignment:
                                                                        MainAxisAlignment
                                                                            .center,
                                                                    children: [
                                                                      Padding(
                                                                        padding: EdgeInsetsDirectional.fromSTEB(
                                                                            0.0,
                                                                            0.0,
                                                                            0.0,
                                                                            16.0),
                                                                        child:
                                                                            Text(
                                                                          'Challenge yourself',
                                                                          style: FlutterFlowTheme.of(context)
                                                                              .bodyMedium
                                                                              .override(
                                                                                fontFamily: 'Roboto',
                                                                                color: FlutterFlowTheme.of(context).white,
                                                                                fontSize: 20.0,
                                                                                letterSpacing: 0.0,
                                                                                fontWeight: FontWeight.bold,
                                                                                useGoogleFonts: false,
                                                                                lineHeight: 1.5,
                                                                              ),
                                                                        ),
                                                                      ),
                                                                      FFButtonWidget(
                                                                        onPressed:
                                                                            () async {
                                                                          FFAppState().selectedQuizType =
                                                                              '';
                                                                          FFAppState().selectedQuizAmount =
                                                                              '';
                                                                          FFAppState().selectedQuizDuration =
                                                                              '';
                                                                          safeSetState(
                                                                              () {});

                                                                          context
                                                                              .pushNamed(SelfChellengeWidget.routeName);
                                                                        },
                                                                        text:
                                                                            'Play now',
                                                                        options:
                                                                            FFButtonOptions(
                                                                          height:
                                                                              40.0,
                                                                          padding: EdgeInsetsDirectional.fromSTEB(
                                                                              24.0,
                                                                              0.0,
                                                                              24.0,
                                                                              0.0),
                                                                          iconPadding: EdgeInsetsDirectional.fromSTEB(
                                                                              0.0,
                                                                              0.0,
                                                                              0.0,
                                                                              0.0),
                                                                          color:
                                                                              Color(0x00FFFFFF),
                                                                          textStyle: FlutterFlowTheme.of(context)
                                                                              .titleSmall
                                                                              .override(
                                                                                fontFamily: 'Roboto',
                                                                                color: FlutterFlowTheme.of(context).white,
                                                                                fontSize: 18.0,
                                                                                letterSpacing: 0.0,
                                                                                fontWeight: FontWeight.w600,
                                                                                useGoogleFonts: false,
                                                                              ),
                                                                          elevation:
                                                                              0.0,
                                                                          borderSide:
                                                                              BorderSide(
                                                                            color:
                                                                                FlutterFlowTheme.of(context).white,
                                                                            width:
                                                                                1.0,
                                                                          ),
                                                                          borderRadius:
                                                                              BorderRadius.circular(12.0),
                                                                        ),
                                                                      ),
                                                                    ],
                                                                  ),
                                                                ),
                                                              ),
                                                            ),
                                                          ),
                                                        ),
                                                      Builder(
                                                        builder: (context) {
                                                          if (FFAppState()
                                                                  .isRewardedVideoAd ==
                                                              1) {
                                                            return Visibility(
                                                              visible: FFAppState()
                                                                      .userPoints <
                                                                  10,
                                                              child: Padding(
                                                                padding: EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                        20.0,
                                                                        16.0,
                                                                        20.0,
                                                                        24.0),
                                                                child: InkWell(
                                                                  splashColor:
                                                                      Colors
                                                                          .transparent,
                                                                  focusColor: Colors
                                                                      .transparent,
                                                                  hoverColor: Colors
                                                                      .transparent,
                                                                  highlightColor:
                                                                      Colors
                                                                          .transparent,
                                                                  onTap:
                                                                      () async {
                                                                    await actions
                                                                        .showRewardedVideoAd(
                                                                      FFAppState()
                                                                          .rewardedPoints,
                                                                      () async {
                                                                        FFAppState().isReward =
                                                                            false;
                                                                        FFAppState()
                                                                            .update(() {});
                                                                        _model.apiResultvte = await QuizGroup
                                                                            .addPointsApiCall
                                                                            .call(
                                                                          userId:
                                                                              getJsonField(
                                                                            FFAppState().userDetils,
                                                                            r'''$.id''',
                                                                          ).toString(),
                                                                          points: FFAppState()
                                                                              .rewardedPoints
                                                                              .toDouble(),
                                                                          description:
                                                                              'ad rewarded points',
                                                                          token:
                                                                              FFAppState().loginToken,
                                                                        );

                                                                        if (QuizGroup.addPointsApiCall.success(
                                                                              (_model.apiResultvte?.jsonBody ?? ''),
                                                                            ) ==
                                                                            1) {
                                                                          FFAppState()
                                                                              .clearCoinsCache();
                                                                          FFAppState()
                                                                              .clearCoinsHistoryCache();
                                                                        }
                                                                      },
                                                                      () async {
                                                                        ScaffoldMessenger.of(context)
                                                                            .showSnackBar(
                                                                          SnackBar(
                                                                            content:
                                                                                Text(
                                                                              'Ad not Available',
                                                                              style: TextStyle(
                                                                                color: FlutterFlowTheme.of(context).primaryText,
                                                                              ),
                                                                            ),
                                                                            duration:
                                                                                Duration(milliseconds: 4000),
                                                                            backgroundColor:
                                                                                FlutterFlowTheme.of(context).secondary,
                                                                          ),
                                                                        );
                                                                      },
                                                                    );

                                                                    safeSetState(
                                                                        () {});
                                                                  },
                                                                  child:
                                                                      Container(
                                                                    height:
                                                                        64.0,
                                                                    decoration:
                                                                        BoxDecoration(
                                                                      color: FlutterFlowTheme.of(
                                                                              context)
                                                                          .primaryText,
                                                                      borderRadius:
                                                                          BorderRadius.circular(
                                                                              12.0),
                                                                    ),
                                                                    child:
                                                                        Padding(
                                                                      padding: EdgeInsetsDirectional.fromSTEB(
                                                                          8.0,
                                                                          0.0,
                                                                          8.0,
                                                                          0.0),
                                                                      child:
                                                                          Row(
                                                                        mainAxisSize:
                                                                            MainAxisSize.max,
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.center,
                                                                        children:
                                                                            [
                                                                          ClipRRect(
                                                                            borderRadius:
                                                                                BorderRadius.circular(8.0),
                                                                            child:
                                                                                Image.asset(
                                                                              'assets/images/Vector.png',
                                                                              width: 20.0,
                                                                              height: 20.0,
                                                                              fit: BoxFit.cover,
                                                                            ),
                                                                          ),
                                                                          RichText(
                                                                            textScaler:
                                                                                MediaQuery.of(context).textScaler,
                                                                            text:
                                                                                TextSpan(
                                                                              children: [
                                                                                TextSpan(
                                                                                  text: 'Watch a video to earn ',
                                                                                  style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                        fontFamily: 'Roboto',
                                                                                        color: FlutterFlowTheme.of(context).info,
                                                                                        fontSize: 18.0,
                                                                                        letterSpacing: 0.0,
                                                                                        fontWeight: FontWeight.w600,
                                                                                        useGoogleFonts: false,
                                                                                        lineHeight: 1.5,
                                                                                      ),
                                                                                ),
                                                                                TextSpan(
                                                                                  text: FFAppState().rewardedPoints.toString(),
                                                                                  style: TextStyle(),
                                                                                ),
                                                                                TextSpan(
                                                                                  text: ' points',
                                                                                  style: TextStyle(),
                                                                                )
                                                                              ],
                                                                              style: FlutterFlowTheme.of(context).bodyMedium.override(
                                                                                    fontFamily: 'Roboto',
                                                                                    color: FlutterFlowTheme.of(context).info,
                                                                                    fontSize: 18.0,
                                                                                    letterSpacing: 0.0,
                                                                                    fontWeight: FontWeight.w600,
                                                                                    useGoogleFonts: false,
                                                                                    lineHeight: 1.5,
                                                                                  ),
                                                                            ),
                                                                          ),
                                                                        ].divide(SizedBox(width: 8.0)),
                                                                      ),
                                                                    ),
                                                                  ),
                                                                ),
                                                              ),
                                                            );
                                                          } else {
                                                            return Container(
                                                              decoration:
                                                                  BoxDecoration(),
                                                            );
                                                          }
                                                        },
                                                      ),
                                                    ].addToStart(
                                                        SizedBox(height: 16.0)),
                                                  ),
                                                ),
                                              );
                                            }
                                          },
                                        ),
                                      );
                                    },
                                  ),
                                );
                              },
                            ),
                          );
                        },
                      ),
                    ),
                  ],
                );
              } else {
                return Align(
                  alignment: AlignmentDirectional(0.0, 0.0),
                  child: Lottie.asset(
                    'assets/jsons/No_Wifi.json',
                    width: 150.0,
                    height: 150.0,
                    fit: BoxFit.contain,
                    animate: true,
                  ),
                );
              }
            },
          ),
        ),
      ),
    );
  }
}
